#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

struct Ant
{
    int pos;
    char type;

    Ant(){}
    Ant(int pos, char type)
        :pos(pos), type(type){}

    friend bool operator < (const Ant& a, const Ant& b)
    {
        return a.pos < b.pos;
    }
};

//wantedDirection = 0 -> left
//wantedDirection = 1 -> right
int rotationCost(bool wantedDirection, char currDirection)
{
    if (wantedDirection == 0)
    {
        if (currDirection == 'l')
            return 0;
        if (currDirection == 'u' || currDirection == 'd')
            return 1;
        if (currDirection == 'r')
            return 2;
    }

    else if (wantedDirection == 1)
    {
        if (currDirection == 'l')
            return 2;
        if (currDirection == 'u' || currDirection == 'd')
            return 1;
        if (currDirection == 'r')
            return 0;
    }

    return -1;
}

const int MAXN = 1e5;
Ant ants[MAXN + 50];
int waitOnLeft[MAXN + 50], waitOnRight[MAXN + 50];
int lCost[MAXN + 50], rCost[MAXN + 50];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++)
        cin >> ants[i].pos >> ants[i].type;

    sort (ants, ants+m);

    for (int i = 0; i < m - 1; i++)
    {
        int rcst = max(waitOnLeft[i], rotationCost(0, ants[i].type));

        if (ants[i+1].pos - ants[i].pos - 1 < rcst)
        {
            int cost = rcst - (ants[i+1].pos - ants[i].pos - 1);
            waitOnLeft[i+1] = max(waitOnLeft[i+1], cost);
        }


        if (i == m-2)
            continue;

        if (ants[i+2].pos - ants[i].pos - 1 < rcst)
        {
            int cost = rcst - (ants[i+2].pos - ants[i].pos - 1);

            waitOnLeft[i+2] = max(waitOnLeft[i+2],cost);
        }


    }

    for (int i = m-1; i > 0; i--)
    {
        int rcst = max(waitOnRight[i], rotationCost(1, ants[i].type));

        if (ants[i].pos - ants[i-1].pos - 1 < rcst)
        {
            int cost = rcst-(ants[i].pos - ants[i-1].pos - 1);
            waitOnRight[i-1] = max(waitOnRight[i-1], cost);
        }


        if (i == 1)
            continue;

        if (ants[i].pos - ants[i-2].pos - 1 < rcst)
        {
            int cost = rcst - (ants[i].pos - ants[i-2].pos - 1);
            waitOnRight[i-2] = max(waitOnRight[i-2], cost);
        }

    }

    for (int i = 0; i < m; i++)
    {
        lCost[i] = max(waitOnLeft[i], rotationCost(0, ants[i].type)) + ants[i].pos;
        rCost[i] = max(waitOnRight[i], rotationCost(1, ants[i].type)) + (n-ants[i].pos + 1);

        /*cout << "i -> " << i << endl;
        cout << "waitOnLeft -> " << waitOnLeft[i] << endl;
        cout << "waitOnRight -> " << waitOnRight[i] << endl << endl;*/
    }

    int ans = min(lCost[m-1], rCost[0]);
    for (int i = 1; i < m-1; i++)
        ans = min(ans, max(lCost[i], rCost[i+1]));

    cout << ans << endl;

    return 0;
}

/*
10
6
4 u
2 d
3 r
8 d
9 d
5 l
*/
